﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Data.SQLite;

namespace SQLite2
{
    public partial class Form1 : Form
    {
        frmAnadir ventanaAnadir;
        static SQLiteConnection conexion;

        public Form1()
        {
            InitializeComponent();
            CrearBBDDSiNoExiste();
            ActualizarListaCiudades();
        }

        private void CrearBBDDSiNoExiste()
        {
            if (!File.Exists("personal.sqlite"))
            {
                // Creamos la conexion a la BD. 
                // El Data Source contiene la ruta del archivo de la BD 
                conexion =
                      new SQLiteConnection
                      ("Data Source=personal.sqlite;Version=3;New=True;Compress=True;");
                conexion.Open();

                // Creamos la primera tabla
                string creacion = "CREATE TABLE ciudad "
                  + "(codigo VARCHAR(2) PRIMARY KEY, nombre VARCHAR(30));";
                SQLiteCommand cmd = new SQLiteCommand(creacion, conexion);
                cmd.ExecuteNonQuery();

                conexion.Close();
            }
        }


        private void InsertarDatos(string codigo, string nombre)
        {

            string insercion;  // Orden de insercion, en SQL
            SQLiteCommand cmd; // Comando de SQLite

            conexion =
              new SQLiteConnection
              ("Data Source=personal.sqlite;Version=3;New=False;Compress=True;");
            conexion.Open();

            try
            {
                insercion = "INSERT INTO ciudad " +
                  "VALUES  ('"+codigo+"','"+nombre+"');";
                cmd = new SQLiteCommand(insercion, conexion);
                cmd.ExecuteNonQuery();
            }
            catch (Exception e)
            {
                MessageBox.Show(
                    "No se ha podido insertar. Posiblemente un codigo esta repetido", 
                    "Aviso");
            }
            conexion.Close();
        }

        private void ActualizarListaCiudades()
        {
            conexion =
              new SQLiteConnection
              ("Data Source=personal.sqlite;Version=3;New=False;Compress=True;");
            conexion.Open();

            lstCiudades.Items.Clear();

            // Lanzamos la consulta y preparamos la estructura para leer datos
            string consulta = "select * from ciudad";
            SQLiteCommand cmd = new SQLiteCommand(consulta, conexion);
            SQLiteDataReader datos = cmd.ExecuteReader();
            // Leemos los datos de forma repetitiva
            while (datos.Read())
            {
                string codigo = Convert.ToString(datos[0]);
                string nombre = Convert.ToString(datos[1]);
                // Y los mostramos
                ListViewItem item = new ListViewItem(codigo);
                item.SubItems.Add(nombre);
                lstCiudades.Items.Add(item);
            }
            conexion.Close();
        }





        private void Form1_Load(object sender, EventArgs e)
        {
            ventanaAnadir = new frmAnadir();
        }

        private void btAnadir_Click(object sender, EventArgs e)
        {
            ventanaAnadir.Limpiar();
            ventanaAnadir.ShowDialog();
            InsertarDatos(ventanaAnadir.GetCodigo(), ventanaAnadir.GetNombre());
            ActualizarListaCiudades();
        }
    }
}
